#include <stdlib.h>

#include "command.h"
#include "cli.h"
#include "config.h"


CLI_COMMAND(mulxFunc);
CLI_COMMAND(mulyFunc);
//CLI_COMMAND(ForceCommandFunc);
CLI_COMMAND(SaveFunc);
CLI_COMMAND(helpFunc);
CLI_COMMAND(connectFunc);

CLI_COMMAND(connectFunc) {
    dev->println("BASICA configuration.");
    dev->println("Type 'help' for help.");
    dev->print ("EEPROM MAGIC:");
    dev->println (get_eeprom_magic(), HEX);
    dev->println();
    
    dev->printPrompt();

    return (0);
}

static const char h1[] PROGMEM="help - display command list";
static const char h2[] PROGMEM = "mulx [1,32] set X multiplier";
static const char h3[] PROGMEM = "muly [1,32] set Y multiplier";
CLI_COMMAND(helpFunc) {
    dev->println(h1);
    dev->println(h2);
    dev->println(h3);
    dev->println("save  - save options in EEPROM");
    //dev->println("force  - force right/left command state");
    
    
    return 0;
}


CLI_COMMAND(mulxFunc) {
  
    if (argc == 1) {
        dev->print("mulx:");
        dev->println(get_mulx());
        return 0;
    }
      
    else if (argc == 2)
    {
        int mulx =  atoi (argv[1]);
        //int mulx =  1;//atoi ("1");
        //mulx=1;
        if (mulx > 0 && mulx < 33)
        {
          set_mulx (mulx);
          
          dev->print("mulx:");
          dev->println(get_mulx());
          return (0);
        }
        else
        {
            dev->println("Usage: mulx - display X multiplier");
            dev->println("Usage: mulx 8- set X multiplier to 8");
            dev->println("Usage: mulx [1,32]");
            return 10;
        }
    }
    
    else
    {
       dev->println("Usage: mulx - display X multiplier");
       dev->println("Usage: mulx 8- set X multiplier to 8");
        return 10;
    }
    
  return (0);
}

CLI_COMMAND(mulyFunc) {
  
    if (argc == 1) {
        dev->print("muly:");
        dev->println(get_muly());
        return 0;
    }  
    else if (argc == 2)
    {
        int muly = atoi (argv[1]);
        
        if (muly > 0 && muly < 33)
        {
          set_muly (muly);
          
          dev->print("muly:");
          dev->println(get_muly());
          return (0);
        }
        else
        {
            dev->println("Usage: muly - display Y multiplier");
            dev->println("Usage: muly 8- set Y multiplier to 8");
            dev->println("Usage: muly [1,32]");
            return 10;
        }
    }
    else
    {
       dev->println("Usage: muly - display Y multiplier");
       dev->println("Usage: muly 8- set Y multiplier to 8");
        return 10;
    }
    
  return (0);
}


CLI_COMMAND(SaveFunc)
{
  if (argc != 1)
  {
      dev->println("Usage: save - Save EEPROM");
      return 10;
  }
  else
  {
    save_config ();
    dev->println("saved");
  }
  return (0);
}

void cli_open ()
{
    Serial.begin(9600);
    CLI.setDefaultPrompt("> ");
    CLI.onConnect(connectFunc);

    
    CLI.addCommand("help", helpFunc);
    CLI.addCommand("mulx", mulxFunc);
    CLI.addCommand("muly", mulyFunc);
    CLI.addCommand("save", SaveFunc);
      
    CLI.addClient(Serial);
}

void cli_close ()
{
}


