
#include <EEPROM.h>
#include "config.h"

#define EEPROM_MAGIC 0x1234FF01
static long _magic =0; // crc version check
static int _mul_X = 1; // position X multiplier
static int _mul_Y = 1; // position X multiplier



void set_mulx (int s)
{
	_mul_X = s;
}
void set_muly (int s)
{
  _mul_Y = s;
}

int get_mulx (void)
{
	return (_mul_X);
}

int get_muly (void)
{
  return (_mul_Y);
} 

void save_config (void)
{
  long magic = EEPROM_MAGIC;
  int eeAddress = 0;

  EEPROM.put(eeAddress, magic);
  eeAddress += sizeof(magic);
  EEPROM.put(eeAddress, _mul_X);
  eeAddress += sizeof(_mul_X);
  EEPROM.put(eeAddress, _mul_Y);
  eeAddress += sizeof(_mul_Y);
}



int  load_config (void)
{
  
  int eeAddress = 0;
  EEPROM.get(eeAddress, _magic);  
  if (_magic != EEPROM_MAGIC)
    return (0);
  eeAddress += sizeof(_magic);
  EEPROM.get(eeAddress, _mul_X);  
  eeAddress += sizeof(_mul_X);
  EEPROM.get(eeAddress, _mul_Y);  
  eeAddress += sizeof(_mul_Y);

  return (1);
}

long get_eeprom_magic (void)
{
  return (_magic);
}

